.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     450

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Buttons for Dogim',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
                        
items	STRUCT
	iStyle	DD	?
	szText	DB	40 DUP (?)
items ENDS
button	items	<BS_PUSHBUTTON,"PUSHBUTTON">
		items	<BS_DEFPUSHBUTTON,"DEFPUSHBUTTON">
		items	<BS_CHECKBOX,"CHECKBOX"> 
		items	<BS_AUTOCHECKBOX,"AUTOCHECKBOX">
		items	<BS_RADIOBUTTON,"RADIOBUTTON">
		items	<BS_3STATE,"3STATE">
		items	<BS_AUTO3STATE,"AUTO3STATE">
	      items	<BS_GROUPBOX,"GROUPBOX">
		items	<BS_AUTORADIOBUTTON,"AUTORADIO">
		items	<BS_OWNERDRAW,"OWNERDRAW">
ButtonClass db  'BUTTON',0
ButtonHandles   dd      10 Dup(?)		
rect        RECT        <>
hMemDC      HDC         ?
szSelected  db      '.\selected.bmp',0
szUnselected db     '.\unsel.bmp',0
hBmpSel     dd          ?
hBmpUnsel   dd          ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControls
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  LoadImage,hInstance,addr szSelected,IMAGE_BITMAP,120,32,LR_LOADFROMFILE
            mov     hBmpSel,eax
            invoke  LoadImage,hInstance,addr szUnselected,IMAGE_BITMAP,120,32,LR_LOADFROMFILE
            mov     hBmpUnsel,eax
            lea esi,button
            assume  esi:PTR items
            lea edi,ButtonHandles
            invoke  GetClientRect,hWnd,addr rect
            mov ecx,10

btn_loop:
            or      [esi].iStyle,WS_VISIBLE+WS_CHILD
            push    ecx
            invoke  CreateWindowEx,NULL,addr ButtonClass,addr [esi].szText,[esi].iStyle,\
                    rect.left,rect.top,120,32,hWnd,NULL,hInstance,NULL
            stosd                                
            pop     ecx
            dec     ecx
            jcxz    end_btn_loop
            add     esi,sizeof items
            add     rect.top,34
            jmp     btn_loop
end_btn_loop:
        assume  esi:NOTHING
        .endif   
    .elseif uMsg==WM_DRAWITEM
        mov edi,lParam
        assume   edi:PTR DRAWITEMSTRUCT
        invoke  CreateCompatibleDC,[edi].hdc
        mov     hMemDC,eax
        test    [edi].itemState,ODS_SELECTED
        jz      unselected
        invoke  SelectObject,hMemDC,hBmpSel
        jmp     draw
unselected:
        invoke  SelectObject,hMemDC,hBmpUnsel
draw:
        invoke  BitBlt,[edi].hdc,[edi].rcItem.left,[edi].rcItem.top,120,32,hMemDC,[edi].rcItem.left,\
                        [edi].rcItem.top,SRCCOPY
        invoke  DeleteDC,hMemDC
        
                    
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end start                                            
